#ifndef __BARCODE_H__
#define __BARCODE_H__

#define LINE_AVG    8       /* Number of vertical pixels to be averaged */
#define LINE_LOCAL  10      /* What counts as a "local" maximum         */
#define LINE_TRES   0.10f   /* Treshold intensity for line (rel.to max) */
#define LINE_TOL    8       /* 1/LINE_TOL = tolerance of line widths    */
#define LINE_NR     4       /* Number of lines required for detection   */
#define SMOOTHING   1
#define CODE_BITS   9
#define CODE_ROWS   4

typedef struct {
    int x0, x1, y0, y1, n;
    int word;
} Bar;

typedef struct {
    int n;
    int alloced;
    size_t size;
    void *data;
} Set;

#endif

