#!/usr/bin/env python

def print_rects(rects):
    print 'newpath'
    for x0,y0,x1,y1 in rects:
        print '%d %d moveto' % (x0,y0)
        print '%d %d lineto' % (x1,y0)
        print '%d %d lineto' % (x1,y1)
        print '%d %d lineto' % (x0,y1)
        print 'closepath'
        print 'fill'
    print 'showpage'

BITS = 7
CODETAB = []

def count_bits(x):
    n = 0
    while x != 0:
        x &= x - 1
        n += 1
    return n

def init_codetab():
    for i in range(1<<BITS):
        bits = count_bits(i)
        if bits == (BITS-1)/2:
            CODETAB.append(1 | (i<<1))
        elif bits == (BITS-1)/2 + 1:
            CODETAB.append(i<<1)

init_codetab()

def encode_row(m, x0, y0, w, h):
    n = CODETAB[m]
    rects = []
    x = x0
    filled = True
    for i in range(BITS+2):
        if (n & (1 << (BITS+1-i))) != 0:
            if filled:
                rects.append((x, y0, x+2*w, y0+h))
            x += 2*w
        else:
            if filled:
                rects.append((x, y0, x+w, y0+h))
            x += w
        filled = not filled
    return rects

def encode_rows(ns, x0, y0, w, h):
    y = y0
    rects = []
    for n in ns[::-1]:
        rects += encode_row(n, x0, y, w, h)
        y += h
    return rects

def encode_word(x, n, chunk=6, codesym=69):
    words = []
    last = -1
    for i in range(n):
        cur = x & ((1<<chunk)-1)
        if last == cur:
            cur = codesym
        words.append(cur)
        x = x >> chunk
        last = cur
    return words

def test():
    rects = encode_rows(encode_word(0, 4), 72, 72, 9, 27)
    rects += encode_rows(encode_word(0xc001deadbeef, 8), 72*5, 72, 9, 27)
    print_rects(rects)

test()

