#ifndef __IMAGE_H__
#define __IMAGE_H__

#include <stdio.h>

typedef struct {
    int x,y,max;
    unsigned char pixels[];
} PPM;

typedef struct {
    int x,y;
    float pixels[];
} Grey;

PPM *ppm_load(FILE *file);
void ppm_write(PPM *ppm, FILE *file);
Grey *ppm_to_grey(PPM *ppm);
PPM *grey_to_ppm(Grey *grey);
Grey *grey_convolute(Grey *grey);
Grey *grey_diff(Grey *grey);
void grey_normalize(Grey *grey);
void grey_rect(Grey *grey, int x0, int y0, int x1, int y1, float c);

#endif

